#include <gtest/gtest.h>
#include "onewaylist.h"

TEST(OnewayList, init) {
    OnewayList<int> initmeagain(2);
    ASSERT_EQ(initmeagain.get(0), 2);
}

TEST(OnewayList, appendingAndRemoving) {
    OnewayList<int> initme;
    initme.append(0);
    initme.append(2);
    initme.append(3);
    initme.append(5);
    EXPECT_EQ(initme.get(1), 2);
    EXPECT_EQ(initme.get(2), 3);
    initme.remove(1);
    EXPECT_EQ(initme.get(1), 3);
    EXPECT_EQ(initme.get(2), 5);
    initme.remove(0);
    EXPECT_EQ(initme.get(1), 5);
    initme.remove(0);
    initme.remove(0);
    initme.append(10);
    EXPECT_EQ(initme.get(0), 10);
    initme.remove(0); //Голову із плечей!
    initme.append(4);
    EXPECT_EQ(initme.get(0), 4);
}
